#if !defined(AFX_AECL21_H__9EA98241_0196_4120_B333_1B0CFBEBA225__INCLUDED_)
#define AFX_AECL21_H__9EA98241_0196_4120_B333_1B0CFBEBA225__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AecL21.h : header file
//

#define MAXCHANNELBUFF 1024
struct B4_L21		// Defines a structure 
{
    BYTE f;		//this order is important!
	BYTE s;
	BYTE m;
	BYTE h;    
} ;

struct W2_L21		// Defines a structure 
{
    WORD sf;	//this order is important!
	WORD hm;
} ;
union DWBYTES_L21	// Declare union type
{
	W2_L21  w;
	B4_L21	b;
	DWORD d;
} ;

#include "Xds.h"
#define L21RAWBUFFER_SIZE 500
#define BUFFER MAX_PATH 
//#define L21RAWBUFFER_SIZE 80
//#define  CC1	1
//#define  CC2	2
//#define  TXT1	3
//#define  TXT2	4
//#define  XDS	5
#define CURRENT		1
#define FUTURE		3
#define CHANNEL		5
#define MISC		7
#define PUBSVC		9
#define RES			11
#define UNDEF		13
#define L21TMREVENT 6

/////////////////////////////////////////////////////////////////////////////
// CAecL21 dialog

class CAecL21 : public CDialog
{
// Construction
public:
	void ReceiveData(int len, LPDWORD s);
	CAecL21(CWnd* pParent = NULL);   // standard constructor
	~CAecL21();

// Dialog Data
	//{{AFX_DATA(CAecL21)
	enum { IDD = IDD_L21_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAecL21)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAecL21)
	afx_msg void OnButtonClrScreen();
	afx_msg void OnRadioF1();
	afx_msg void OnRadioF2();
	afx_msg void OnRadioCc1();
	afx_msg void OnRadioCc2();
	afx_msg void OnRadioT1();
	afx_msg void OnRadioT2();
	afx_msg void OnRadioXds();
	afx_msg void OnButtonCloseL21();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonPause();
	afx_msg void OnCheckSave();
	afx_msg void OnButton0time();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	int L21overflow;
	int m_iSaveLoopCnt;
	void CheckToSave();
	void TextToView(LPCTSTR lpS);
	//WORD wDaysInYear[] = {0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365};
	DWORD CalcSeconds(WORD h, WORD m, WORD s);
	TCHAR sElapsed[15];
	void ElapsedTime();
	
	LPTSTR lpszPath;
	TCHAR tchBuffer[BUFFER]; 
	HANDLE hFile;
	SYSTEMTIME tmNow;
	SYSTEMTIME tm0;
	int ProcessXDS();
	char CheckTranslate(char ct);
	char MapSpecialChar(char b);
	BOOL ProcessCode(char ch1, char ch2);
	BOOL m_CRprior;
	BOOL m_CRpriorSave;
	int CheckMode(BYTE char2);
	int m_mode;
	int m_channel;
	BOOL m_ViewField;
	char m_char2;
	char m_char1;
	int Control(DWORD dwQues);
	void L21SortSingle(DWORD dwL21);
	void OutputChoice();
	void SortL21Data();
	int m_L21SortIndex;
	int m_L21MaxIndex;
	int m_L21Index;
	int m_iCurrent;
	int m_iSave;
//	int m_iCC2;
//	int m_iCC3;
//	int m_iCC4;
//	int m_iTXT1;
//	int m_iTXT2;
//	int m_iTXT3;
//	int m_iTXT4;
//	int m_iXDS;
	int m_CurrentChannelSelection;
	int m_CurrentChannel;

	char m_sCurrentChannel[MAXCHANNELBUFF];
	char m_sSave[MAXCHANNELBUFF];
//	char m_sTXT1[256];
//	char m_sCC2[256];
//	char m_sTXT2[256];
//	char m_sCC3[256];
//	char m_sTXT3[256];
//	char m_sCC4[256];
//	char m_sTXT4[256];
//	char m_sXDS[256];

	BOOL m_L21RollOver;
	BOOL m_pause;
	DWORD m_dwCntTest;
	UINT m_tmr;
	UINT m_L21_Timer;
	void OutputRaw();
	DWORD m_bufferL21[L21RAWBUFFER_SIZE];
	BOOL m_L21Event;
	CWnd* m_pMainDlg;
	void SendToMain(WPARAM wp, LPARAM lp);
	CXds xds;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AECL21_H__9EA98241_0196_4120_B333_1B0CFBEBA225__INCLUDED_)
