#if !defined(AFX_AECSIO_H__552545E1_F8DC_4667_93B1_0B73ACC66250__INCLUDED_)
#define AFX_AECSIO_H__552545E1_F8DC_4667_93B1_0B73ACC66250__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// AecSio.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CAecSio dialog

class CAecSio : public CDialog
{
// Construction
public:
	void ReceiveData(int len, LPWORD s);
	CAecSio(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CAecSio)
	enum { IDD = IDD_SIO_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAecSio)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAecSio)
	afx_msg void OnCheckHex();
	afx_msg void OnCloseSio();
	afx_msg void OnRadioBaud4800();
	afx_msg void OnRadioBaud28000();
	afx_msg void OnRadioBaud9600();
	afx_msg void OnRadioBaud19200();
	afx_msg void OnRadioBaud33000();
	afx_msg void OnRadioBaud38400();
	afx_msg void OnRadioBaud76800();
	afx_msg void OnRadioParityOdd();
	afx_msg void OnRadioParityEven();
	afx_msg void OnRadioParityNone();
	afx_msg void OnRadioBits8();
	afx_msg void OnRadioBits7();
	afx_msg void OnButtonTxClear();
	afx_msg void OnButtonRxClear();
	afx_msg void OnButtonLoad0();
	afx_msg void OnButtonLoad1();
	afx_msg void OnButtonLoad2();
	afx_msg void OnButtonLoad3();
	afx_msg void OnButtonLoad4();
	afx_msg void OnButtonLoad5();
	afx_msg void OnButtonLoad6();
	afx_msg void OnButtonLoad7();
	afx_msg void OnButtonLoad8();
	afx_msg void OnButtonLoad9();
	afx_msg void OnButtonLoadA();
	afx_msg void OnButtonLoadB();
	afx_msg void OnButtonLoadC();
	afx_msg void OnButtonLoadD();
	afx_msg void OnButtonLoadE();
	afx_msg void OnButtonLoadF();
	afx_msg void OnButtonTx0();
	afx_msg void OnButtonTx1();
	afx_msg void OnButtonTx2();
	afx_msg void OnButtonTx3();
	afx_msg void OnButtonTx4();
	afx_msg void OnButtonTx5();
	afx_msg void OnButtonTx6();
	afx_msg void OnButtonTx7();
	afx_msg void OnButtonTx8();
	afx_msg void OnButtonTx9();
	afx_msg void OnButtonTxA();
	afx_msg void OnButtonTxB();
	afx_msg void OnButtonTxC();
	afx_msg void OnButtonTxD();
	afx_msg void OnButtonTxE();
	afx_msg void OnButtonTxF();
	afx_msg void OnButtonClrInput();
	afx_msg void OnRadioBaud2400();
	afx_msg void OnButtonInitSio();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	char CharProc(char c);
	UINT m_tmr;
	BOOL m_RxEvent;
	int m_rxIndex;
	WORD m_rxW[256];
	BOOL ProcessRxData();
	BYTE m_BitsParity;
	void TxDisplay(LPARAM tx_n);
	char m_Stuffed[256];
	void SaveStuff(int index, BYTE *b);
	void Stuff(LPARAM lp);
	BOOL m_Hex;
	BYTE m_ByteArray[255];
	int m_InLen;
	int GetInput();
	char m_LdBuf[255];
	CWnd* m_pMainDlg;
	void SendToMain(WPARAM wp, LPARAM lp);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AECSIO_H__552545E1_F8DC_4667_93B1_0B73ACC66250__INCLUDED_)
